-- text entry library
local gr = love.graphics

local	te = {
	active   = false,
	text     = { "", "" },
	finished = false,
	start    = true,	-- to trap activation key input
	draw     = function( te, header, x, y, fclr, bclr, sz )
		te.text[1] = header
		if not te.active then
			if te.finished then
				te.finished = false
				return te.rtn
				end
			else
			tb = nil
			end
		if te.active then
			textBox( te.text, x, y, fclr, bclr, sz )
			end
		end,
	keys = function(te, k )
		if k == 'return' then
			te.active = false
			if #te.text[2]>0 then te.rtn = te.text[2]	-- text add until 'enter'
				te.text[2] = ''
				te.finished	= true
				end
			end
		if k == 'backspace' then
			te.text[2] = string.sub( te.text[2], 1, #te.text[2]-1 )
			end
		if k == 'escape' then
			te.active = false
			te.finished =true
			te.text[2] = ''
			return false
			end
		end
	}

te.trapKey = function( key, k )	-- key, activation key
	if te.active then
		te:keys( key )		-- check if return or backspace pressed
		return true, nil
		end
	if key == k then		-- start text input
		local entry = true
		te.active = true
		te.start = true
		return entry, nil	-- don't allow keys activate other options
		end
	return nil, key		-- return key not used for text entry
	end

function love.textinput( k )
	if te.active then
		if not te.start then	-- don't add activation key to text
			te.text[2] = te.text[2] .. k
			else
			te.start = false
			end
		end
	end

local fontDim = function( str, sz )
	local font = gr.getFont()
	return font:getWidth( str ), font:getHeight()
	end

textBox = function( lines, x, y, fclr, bclr, fontsize ) -- centered on x,y
	local wd, w, h = 0
	local lines = type( lines ) == 'table' and lines or { lines }
	oldfont = love.graphics.getFont( )
	if fontsize then gr.setFont( gr.newFont( fontsize ) ) end
	for i = 1, #lines do
		w, h = fontDim( lines[i] )
		wd = w > wd and w or wd
		end
	gr.setColor( bclr or {0,0,0} )
	local x, y = x-(wd+h)/2, y-(#lines*h+h)/2
	gr.rectangle( 'fill', x, y, wd+h, #lines*h+h, 5, 5 )
	gr.setColor( fclr or {1,1,1} )
	for i = 1, #lines do
		gr.print( lines[i], x+h/2, y+h*i-h/2 )
		gr.print( lines[i], x+h/2, y+h*i-h/2 )
		end
	gr.rectangle( 'line', x, y, wd+h, #lines*h+h, 5, 5 )
	gr.setFont(oldfont)
	return { x, y, wd, h }, #lines
	end

return te